#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>

void obsluha(int nevyuzity_par); 	/* obsluzna rutina SIGUSR1 - pouze "probudi" proces */
void print_table(int t1, int t2, int t3, int t4);	/* vypis tabulky */

int main(int argc, char *argv[])
{
  int t1, t2, t3, t4;
  int i;
  int spid;
  int fd;
  char buf[10];

  if (argc != 6) {			/* osetreni vstupnich parametru */
    printf("Nespravne zadane parametry!\n");
    return(1);
  }
  fd = open("3.txt", O_RDWR);		/* vytvoreni souboru */

  t1 = atoi(argv[2]);			/* prevod parametru na cas */
  t2 = atoi(argv[3]);
  t3 = atoi(argv[4]);
  t4 = atoi(argv[5]);

  signal(SIGUSR1, obsluha);		/* prirazeni obsluzne rutiny signalu */
  spid = fork();
  if (spid == 0) {			/* proces slave */
    pause();
    sleep(t3);
    printf("read1 ");
    read(fd, buf, sizeof(buf));
    sleep(t4);
    printf("read2 ");
    read(fd, buf, sizeof(buf));
  }
  else {   				/* proces master */
    print_table(t1, t2, t3, t4);
    kill(spid, SIGUSR1);
    sleep(t1);
    printf("write1 ");
    for (i = 0; i < 10; i++)
      write(fd, argv[1], sizeof(char));
    sleep(t2);
    printf("write2 ");
    for (i = 0; i < 10; i++)
      write(fd, argv[1], sizeof(char));
  }
  return(0);
}

void obsluha(int nevyuzity_par)		
{
}

void print_table(int t1, int t2, int t3, int t4)
{                              		
  printf("WRITE   |   READ\n");		
  printf("t1|t2   |   t3|t4\n");
  printf("---------------------------------------------------\n");
  printf("%d  %d    |   %d  %d\t", t1, t2, t3, t4);
}